#!/usr/bin/python

# Copyright (c) 2007, David Bender, Benegon Enterprises LLC
# All rights reserved.

# Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

#   * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
#   * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
#   * Neither the name of the Benegon Enterprises LLC nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# The diskegrator is hosted at
# http://diskegrator.sourceforge.net

import sys
import subprocess
import os
import shutil

from benegon.target import *
from benegon.partition import *
from benegon.bootloader import *

# Partitions are defined by
# (target mount point, type, filename, size)
# The specified order of partitions is what will be used on the target

# Scope of the diskegrator
# Should work with directories to which all relevant files have
# been copied unless those files are "standard" files; that is
# -the files should never need to be touched by the user
# -which files to copy are inferred from the input config file

if __name__ == "__main__":
	if len(sys.argv) < 2:
		print >> sys.stderr, "Please specify config!"
		sys.exit(1)

	# Read configuration
	cfgFile = sys.argv[1]
	exec(file(cfgFile).read())

	# "Parse" pieces
	target = cfg[0]
	parts = cfg[1]
	bootloader = cfg[2]

	# Initialize target device
	target.initialize(parts)

	# populate partitions
	index = 1
	for entry in parts:
		devNode = target.getDevNode(index)
		entry.populate(devNode)
		index += 1
	
	# Install the bootloader
	bootloader.install(target.getDevNode(0))
