from benegon.target import *
from benegon.partition import *
from benegon.grub import *

# The diskegrator is hosted at
# http://diskegrator.sourceforge.net

# This configuration will create a disk image at
# disk partition sdb5 (as opposed to just sdb!)
# -The first parition will be a small ext2 part containing boot info
# -The second partition is a 512MB swap partition
# -The third partition is our rootfs, which we have already populated
#  in the staging directory. It will be 6GB in size.
# -Finally, install grub to the first partition, using the config 'vm.conf'

# Invoke with
# diskegrator build.py

cfg = (\
	Loopback('/dev/sdb5'),
	[
		FileSystem('ext2', 0x1000000, 'boot'),
		Swap(512 * 1024 * 1024),
		FileSystem('reiserfs', 6000 * 1024 * 1024, 'staging'),
	],
	Grub('vm.conf', 1)
)
